#################################s#o#q######################################
## by Arthur Chan @ soqhome.com
#############################################################################


from Products.SoQClub.config import *
from Products.Archetypes.public import *
from Products.CMFCore import CMFCorePermissions
from OFS.Image import File
from AccessControl import ClassSecurityInfo

#############################################################################
##                             Setting                                     ##
#############################################################################

schema = BaseSchema +  Schema((
    StringField('title',
             required=1,
             searchable=1,
        ),
    StringField ('mimetype',
             vocabulary=SOQAUDIO_MIMETYPE,
             required=1,
             widget=SelectionWidget(label="File Format"),
        ),
    FileField('audio',
             required=1,
             mutator='setAudio',
             primary=1,
             mimetype='video/x-ms-wmv',
             widget=FileWidget(label="Audio"),
        ),
    TextField('body',
             searchable=1,
             required=1,
             default_content_type = 'text/html', 
             default_output_type = 'text/html', 
             widget=VisualWidget(label="Description",
                               description="Description about the audio",
                       ),
        ),
    ))
    
class SoQAudio(BaseContent):
    """This is a Image object
    """
    security = ClassSecurityInfo()    
    schema = schema
    archetype_name = "SoQ Audio"
    global_allow = 0
    actions = ({
        'id': 'view',
        'name': 'View',
        'action': 'soqaudio_view',
        'permissions': (CMFCorePermissions.View,) 
        },
        )
        
    #############################################################################
    ##                             Basics                                      ##
    #############################################################################
    
    security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'setAudio' )        
    def setAudio(self, value):
        schema = self.Schema()
        field = schema.get('audio', None)
        mimetype= self.REQUEST['mimetype']
        field.set(instance=self, value=value)
        
        self._FileField_types['setAudio'] = mimetype
        
    #############################################################################
    ##                             Utils                                       ##
    #############################################################################

    security.declareProtected( CMFCorePermissions.View, 'getAudioFile' )
    def getAudioFile(self):
        schema = self.Schema()
        field = schema.get('audio', None)
        mimetype = self.getMimetype()
        ext = self.getContentExtension(mimetype)
        data = field.get(self)
        RESPONSE = self.REQUEST.RESPONSE
        RESPONSE.setHeader('Content-Type', mimetype)
        RESPONSE.setHeader('Content-Length', len(data))
        RESPONSE.setHeader('Content-Disposition', 'attachment; filename=%s.%s' % (self.getId(), ext))

        return data
        
    security.declarePublic( 'getContentExtension' )
    def getContentExtension(self, mimetype=''):
        ret = ''
        if mimetype =='':
            mimetype = self.getMimetype()
        
        if mimetype == 'application/vnd.rn-realmedia':
            ret = 'rm'
        elif mimetype =='audio/wav':
            ret = 'wav'
        elif mimetype =='audio/x-aiff':
            ret = 'aif'
        elif mimetype =='audio/mid':
            ret = 'mid'
            
        return ret
           
registerType(SoQAudio)
