#################################s#o#q######################################
## by Arthur Chan @ soqhome.com
#############################################################################


from Products.SoQClub.config import *
from Products.SoQClub.Widget import *

from Products.Archetypes.public import *
from Products.CMFCore import CMFCorePermissions
from AccessControl import ClassSecurityInfo


#############################################################################
##                             Setting                                     ##
#############################################################################

schema = BaseFolderSchema +  Schema((
    StringField('title',
                searchable=1,
                required=1,
                ),
    TextField('description',
              searchable=1,
              widget=TextAreaWidget,
              ),
    ImageField('image',
              required=1,
              allowable_content_types=('image/*',),
              sizes={ 'mini'   : (80,80),
                  'small'  : (120,120),
                  'normal' : (200,200),
                  'big'    : (300,300),
                  'maxi'   : (500,500)},
              widget=ImageWidget(label='File'),
              ),
    CMFObjectField('reference',
              portal_type='Link',
              addable=1,
              destination='',
              allowed_types=('Link',),
              multiValued=1,
              widget=SoQFieldWidget(allowed_types_names=('Link',)),
              ),
    ))

class SoQPoster(BaseFolder):
    """This is a Poster object
    """
    security = ClassSecurityInfo()
    
    schema = schema
    archetype_name = "SoQ Poster"
    allowed_content_types = ['Link']
    
    global_allow = 0
    
    actions = ({
        'id': 'view',
        'name': 'View',
        'action': 'soqposter_view',
        'permissions': (CMFCorePermissions.View,) 
        },
        { 'id'            : 'order'
        , 'name'          : 'Order'
        , 'action'        : 'portal_form/PloneFolder_orderForm'
        , 'permissions'   :  (CMFCorePermissions.ModifyPortalContent,)
        , 'category'	  : 'object'
        , 'visible':1
        },
        { 'id'            : 'references'
        , 'name'          : 'References'
        , 'action'        : 'portal_form/reference_edit'
        , 'permissions'   :  (CMFCorePermissions.ModifyPortalContent,)
        , 'visible':0
        },
        )
        
    #############################################################################
    ##                             Basics                                      ##
    #############################################################################

    def __init__(self
                , id
                , title=''
                , **kwarg):
        BaseFolder.__init__(self, id, title=title, **kwarg)
        
        ## add properties
        self.manage_addProperty('left_slots', SOQAUXILIARY_SLOTS_BASICLEFT, 'lines')
        self.manage_addProperty('right_slots', SOQAUXILIARY_SLOTS_BASICRIGHT, 'lines')

    security.declarePrivate('manage_afterAdd')
    def manage_afterAdd(self, item, container):
        BaseFolder.manage_afterAdd(self, item, container)
        #self.manage_addProperty('left_slots', SOQAUXILIARY_SLOTS_BASICLEFT, 'lines')
        #self.manage_addProperty('right_slots', SOQAUXILIARY_SLOTS_BASICRIGHT, 'lines')


    
    #############################################################################
    ##                             Utils                                       ##
    #############################################################################

    security.declarePrivate( 'comparaison' )    
    def comparaison(self, x,y):
        if hasattr(self, 'order'):
            list_ref = self.order  
            if  x.getId() not in list_ref:
               return 1
            if  y.getId() not in list_ref:
               return -1
            xid=list_ref.index(x.getId())
            yid=list_ref.index(y.getId())
        else:
            xid =x.getId()
            yid = y.getId()
            
        if xid<yid:
            return -1
        elif xid>yid:
            return +1
        else:
            return 0

    security.declareProtected(CMFCorePermissions.View, 'listPosterFolderContents')
    def listPosterFolderContents( self, spec=None, contentFilter=None, **kwargs ):
        #results = BaseFolder.listFolderContents( self, spec, contentFilter )
        results = BaseFolder.contentValues( self, spec, contentFilter )
        
        if kwargs.has_key('state'):
            state = kwargs['state']
        else:
            state = ''
        
        if state <> '':
            ret = []
            wf = self.portal_workflow
            for result in results:
                if wf.getInfoFor(result,'review_state', '') == state :
                    ret.append(result)
        else:
            ret = results
        
        ret.sort(self.comparaison)
        return ret    
        
registerType(SoQPoster)
