#################################s#o#q######################################
## by Arthur Chan @ soqhome.com
#############################################################################

from Products.SoQClub.config import *
from Products.Archetypes.public import *
from Products.CMFCore import CMFCorePermissions
from AccessControl import ClassSecurityInfo
from Products.SoQClub.Widget import *

#############################################################################
##                             Setting                                     ##
#############################################################################

schema = BaseSchema +  Schema((
    StringField('title',
                searchable=1,
                required=1,
                ),
    StringField('channelurl'
                ,searchable=1
                ,default='http://channel.soqhome.com/RSSChannel'
                ,label='Remote Channel URL'
                ,required=1
                ,validator='isURL'
                ),
    ))

def addSoQRemoteChannel( self, id, title='', channelurl='', REQUEST=None ):
    ch = SoQRemoteChannel( id )
    ch.id = id
    if REQUEST is not None:
        ch.title = REQUEST['title']
        ch.channelurl = REQUEST['channelurl']
    else:
        ch.title = title
        ch.channelurl = channelurl
    
    
    self._setObject( id, ch )
    if REQUEST is not None:
        REQUEST['RESPONSE'].redirect(self.absolute_url() +\
                                             "?portal_status_message=remote+channel+created")

class SoQRemoteChannel(BaseFolder):
    security = ClassSecurityInfo()
    schema = schema
    archetype_name = "SoQ Remote Channel"
    global_allow = 0
    
    actions = (
        {
        'id': 'view',
        'name': 'View',
        'action': 'soqremotechannel_view',
        'permissions': (CMFCorePermissions.View,)
        },
        { 'id'            : 'metadata'
        , 'name'          : 'Properties'
        , 'action'        : 'portal_form/base_metadata'
        , 'permissions'   :  (CMFCorePermissions.ManageProperties,)
        , 'category'	  : 'object'
        , 'visible':0
        },
        { 'id'            : 'references'
        , 'name'          : 'References'
        , 'action'        : 'portal_form/reference_edit'
        , 'permissions'   :  (CMFCorePermissions.ModifyPortalContent,)
        , 'category'	  : 'object'
        , 'visible':0
        },
        { 'id'            : 'content_status_history'
        , 'name'          : 'state'
        , 'action'        : 'portal_form/content_status_history'
        , 'permissions'   :  (CMFCorePermissions.ModifyPortalContent,)
        , 'category'	  : 'object'
        , 'visible':0
        },
        )
    
    
    #############################################################################
    ##                             Basics                                      ##
    #############################################################################


    def __init__(self
                , id
                , title=''
                , **kwarg):
        BaseFolder.__init__(self, id, title=title, **kwarg)
        
        #XMLRPCProxy.__init__(self.id, 'RProxy', title='Remote XMLRPCProxy')
        
    security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'setChannelurl' )
    def setChannelurl(self, value):
        schema = self.Schema()
        field = schema.get('channelurl', None)
        field.set(instance=self, value=value)
        rproxy = self['RProxy']
        rproxy.url = value
        rproxy.ValidMethodList = SOQREMOTECHANNEL_VALIDMETHODLIST
        
        #self.aq_parent.modifyChannels()

    security.declarePrivate('manage_afterAdd')
    def manage_afterAdd(self, item, container):
        BaseFolder.manage_afterAdd(self, item, container)
        
                
        
        #self[id].manage_addProduct['XMLRPCProxy'].XMLRPCProxy_add(id='RProxy', REQUEST=None)
        if not hasattr(self, 'RProxy'):
            req = {'id':'RProxy', 'url':self.channelurl,}
            self.manage_addProduct['XMLRPCProxy'].XMLRPCProxy.createInObjectManager('RProxy',REQUEST=req)
	    #self['RProxy'].propertysheets.XMLRPCProxy.manage_changeProperties({'url':self.channelurl, 'ValidMethodList':  SOQREMOTECHANNEL_VALIDMETHODLIST})
	    rproxy = self['RProxy']
            rproxy.url = self.channelurl
            #rproxy.manage_changeProperties({'url':self.channelurl,})
            rproxy.ValidMethodList = SOQREMOTECHANNEL_VALIDMETHODLIST
        


    security.declarePrivate('manage_beforeDelete')
    def manage_beforeDelete(self, item, container):
        BaseFolder.manage_beforeDelete(self, item, container)
        #self.aq_parent.modifyChannels(exclude=[self.id])
        
registerType(SoQRemoteChannel)
